<?php
namespace Incoviba\Model\Proyecto;

use DateTimeInterface;
use Incoviba\Common\Ideal;
use Incoviba\Model;

class EstadoProyecto extends Ideal\Model
{
    protected ?Model\Proyecto $proyecto;
    public TipoEstadoProyecto $tipoEstadoProyecto;
    public DateTimeInterface $fecha;

    public function proyecto(): Model\Proyecto
    {
        if (!isset($this->proyecto)) {
            $this->proyecto = $this->runFactory('proyecto');
        }
        return $this->proyecto;
    }

    public function jsonSerialize(): mixed
    {
        return array_merge(parent::jsonSerialize(), [
            'proyecto' => $this->proyecto(),
            'tipo_estado_proyecto' => $this->tipoEstadoProyecto,
            'fecha' => $this->fecha
        ]);
    }
}
